//
//  main.cpp
//  Problem2
//
//  Created by Tammy on 6/10/15.
//  Copyright (c) 2015 Tammy. All rights reserved.
//

#include <iostream>
using namespace std;
// Animal class
class Animal{
protected:
    string name;
    int height;
    int weight;
    int energy;
    void energyCost(int cost);
public:
    Animal(string n, int h, int w, int e);
    virtual void exercise(int hour) = 0; // absolute virtual function
    virtual void print(); // virtual function
    string getName();
    int getEnergy();
};
// constructor
Animal::Animal(string n, int h, int w, int e): name(n), height(h), weight(w), energy(e) {}
// print the private information of parent class
void Animal::print(){
    cout << this->name << ": Height " << this->height << ", Weight " << this->weight << endl;
}
// energyCost function, decrease the energy
void Animal::energyCost(int cost){
    energy -= cost;
}
// return the animal's name
string Animal::getName(){
    return this->name;
}
// return the animal's energy
int Animal::getEnergy(){
    return this->energy;
}

//Animal's children class Elephant
class Elephant : public Animal{
private:
    // frequency and cost for every Elephant
    static const int freq = 8;
    static const int cost = 50;
public:
    // constructor
    Elephant(string eN, int eH, int eW, int eE) : Animal(eN,eH,eW,eE){}
    void print() { // override print function
        cout << "Elephant ";
        Animal::print(); // print private information
        if(energy<=0){
            cout << Animal::getName() << " is hungry." << endl;
        }
    }
    void exercise(int hour) // override exercise function
    {
        int time = hour / freq; // calculate how many time the elephant needs to exercise
        for(int i=0; i<time; i++){
            if(energy>0){ // print the information
                cout << Animal::getName() << " is doing exercise by wallowing in the mud." << endl;
                energyCost(this->cost);
                cout << Animal::getName() << " has " << Animal::getEnergy() << " energy left." << endl;
            }
            else{
                cout << Animal::getName() << " has no energy to do exercise." << endl;
            }
        }
    }
};
//Animal's children class Koala
class Koala : public Animal{
private:
    // frequency and cost for every Koala
    static const int freq = 12;
    static const int cost = 30;
public:
    // constructor
    Koala(string kN, int kH, int kW, int kE) : Animal(kN,kH,kW,kE){}
    void print() { // override print function
        cout << "Koala ";
        Animal::print();
        if(energy<=0){
            cout << Animal::getName() << " is hungry." << endl;
        }
    }
    void exercise(int hour) // override exercise function
    {
        int time = hour / freq; // calculate how many time the elephant needs to exercise
        for(int i=0; i<time; i++){
            if(energy>0){ // print the information
                cout << Animal::getName() << " is doing exercise by climbing the tree." << endl;
                energyCost(this->cost);
                cout << Animal::getName() << " has " << Animal::getEnergy() << " energy left." << endl;
            }
            else{
                cout << Animal::getName() << " has no energy to do exercise." << endl;
            }
        }
    }
};
int main() {
    Animal* c[3]; // declare array with Animal type
    c[0] = new Elephant("E1",150,300,90); // polymorphism
    c[1] = new Koala("K1",50,65,40);
    c[2] = new Koala("K2",20,30,5);
    for(int i=0; i<3; i++){
        int hour = 0;
        cin >> hour; // input the hour for exercise function
        c[i]->exercise(hour);
    }
    for(int i=0; i<3; i++){
        c[i]->print();
    }
    return 0;
}
