//
//  main.cpp
//  Lab#16
//
//  Created by Tammy on 6/9/15.
//  Copyright (c) 2015 Tammy. All rights reserved.
//

#include <iostream>
using namespace std;
// Animal class
class Animal{
protected:
    string name;
    int height;
    int weight;
    int energy;
    void energyCost(int cost);
    void eat(const int preference[], int count);
public:
    Animal(string n, int h, int w, int e);
    virtual void exercise(int hour) = 0; // absolute virtual function
    virtual void print(); // virtual function
    string getName();
    int getEnergy();
};
// constructor
Animal::Animal(string n, int h, int w, int e): name(n), height(h), weight(w), energy(e) {}

// print the private information of parent class
void Animal::print(){
    cout << this->name << ": Height " << this->height << ", Weight " << this->weight << endl;
}

// energyCost function, decrease the energy
void Animal::energyCost(int cost){
    energy -= cost;
}
// eat function
void Animal::eat(const int preference[], int count){
    for(int i=0; i<count; i++){
        energy += preference[i]; // increase the energy by it's preference
    }
}
// return the animal's name
string Animal::getName(){
    return this->name;
}
// return the animal's energy
int Animal::getEnergy(){
    return this->energy;
}
//Animal's children class Elephant
class Elephant : public Animal{
private:
    // frequency, cost and foodPreference for every Elephant
    static const int freq = 8;
    static const int cost = 50;
    static const int foodPreference[3];
public:
    // constructor
    Elephant(string eN, int eH, int eW, int eE) : Animal(eN,eH,eW,eE){}
    void print() { // override print function
        cout << "Elephant ";
        Animal::print();
        while(energy<=0){ // if the elephant is still hungry
            cout << Animal::getName() << " is hungry." << endl;
            Animal::eat(foodPreference,3); // invoke the eat function
            cout << Animal::getName() << " has " << Animal::getEnergy() << " energy left." << endl;
        }
    }
    void exercise(int hour) // override exercise function
    {
        int time = hour / freq;
        for(int i=0; i<time; i++){
            if(energy>0){
                cout << Animal::getName() << " is doing exercise by wallowing in the mud." << endl;
                energyCost(this->cost);
                cout << Animal::getName() << " has " << Animal::getEnergy() << " energy left." << endl;
            }
            else{
                cout << Animal::getName() << " has no energy to do exercise." << endl;
            }
        }
    }
};
const int Elephant::foodPreference[3] = {5,5,5}; // initialize the foodPreference function
//Animal's children class Koala
class Koala : public Animal{
private:
    // frequency, cost and foodPreference for every Elephant
    int freq = 12;
    int cost = 30;
    static const int foodPreference[3];
public:
    // constructor
    Koala(string kN, int kH, int kW, int kE) : Animal(kN,kH,kW,kE){}
    void print() { // override print function
        cout << "Koala ";
        Animal::print();
        while(energy<=0){ // if the koala is still hungry
            string n = Animal::getName();
            cout << n << " is hungry." << endl;
            Animal::eat(foodPreference,3); // invoke the eat function
            cout << Animal::getName() << " has " << Animal::getEnergy() << " energy left." << endl;
        }
    }
    void exercise(int hour) // override exercise function
    {
        int time = hour / freq;
        for(int i=0; i<time; i++){
            if(energy>0){
                cout << Animal::getName() << " is doing exercise by climbing the tree." << endl;
                energyCost(this->cost);
                cout << Animal::getName() << " has " << Animal::getEnergy() << " energy left." << endl;
            }
            else{
                cout << Animal::getName() << " has no energy to do exercise." << endl;
            }
        }
    }
};
const int Koala::foodPreference[3] = {5,0,2}; // initialize the foodPreference function
int main() {
    Animal* c[3]; // declare array with Animal type
    c[0] = new Elephant("E1",150,300,90); // polymorphism
    c[1] = new Koala("K1",50,65,40);
    c[2] = new Koala("K2",20,30,5);
    for(int i=0; i<3; i++){
        int hour = 0;
        cin >> hour; // input the hour for exercise function
        c[i]->exercise(hour);
    }
    for(int i=0; i<3; i++){
        c[i]->print();
    }
    return 0;
}
